<?php
class DBTables {

	
	/**
	 * Constructor function
	 *
	 * @return DBTables
	 */
	function DBTables() {
		
	}
	
	
	/**
	 * Enter description here...
	 *
	 */
	function initDBTables() {
		global $wpdb;

		require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
		
		$sf_surveys_db_version = get_option('sf_surveys_db_version');

		
		if ($wpdb->get_var("SHOW TABLES LIKE '{$wpdb->prefix}sf_surveys'") != $wpdb->prefix . 'sf_surveys') {
			dbDelta("CREATE TABLE {$wpdb->prefix}sf_surveys (
						survey_id integer not null auto_increment,
						survey_name varchar(250),
						survey_key varchar(25),
						tab_image varchar(250),
						background_color varchar(10),
						background_image varchar(250),
						border_color varchar(10),
						border_size integer,
						all_pages boolean,
						post_ids text,
						category_ids text,
						lightbox_image varchar(250),
						use_widget boolean,
						use_cookie boolean,
						cookie_days integer,
						width integer,
						height integer,
						padding integer,
						question_background_color varchar(10),
						answer_images text,
						answer_flows text,
						active_status_id integer,
						date_modified timestamp,
						date_created timestamp,
     					use_shortcode boolean,
     						
						PRIMARY KEY (survey_id)
					);");

			//add_option("sf_surveys_db_version", "2.3");
			add_option("sf_surveys_db_version", "4.3");  //Added by Pallavi in 4.3v to set db version
		}
		 else if($wpdb->get_var("SHOW TABLES LIKE '{$wpdb->prefix}sf_surveys'") == $wpdb->prefix . 'sf_surveys')
		{
			$sql = "SHOW COLUMNS FROM {$wpdb->prefix}sf_surveys LIKE 'category_ids'";
			if(!$wpdb->get_var($sql) )
			{
				$sql2 = "alter table {$wpdb->prefix}sf_surveys add category_ids text after post_ids";
				$wpdb->query($sql2);
			}
			//Add code for adding use_shortcode col begin by Dinesh
			
			$sql = "SHOW COLUMNS FROM {$wpdb->prefix}sf_surveys LIKE 'use_shortcode'";
			if(!$wpdb->get_var($sql) )
			{
				$sql2 = "alter table {$wpdb->prefix}sf_surveys add use_shortcode boolean after date_created";
				$wpdb->query($sql2);
			}
			// End by dinesh
		}		
			
		if ($sf_surveys_db_version < '2.0' ) {
			maybe_add_column("{$wpdb->prefix}sf_surveys", "lightbox_image", "ALTER TABLE {$wpdb->prefix}sf_surveys ADD COLUMN lightbox_image varchar(250);");
			//update_option('sf_surveys_db_version', '2.0');
			update_option('sf_surveys_db_version', '4.3');  //Added by Pallavi in 4.3v to set db version
		}
		
		if ($sf_surveys_db_version < '2.1' ) {
			maybe_add_column("{$wpdb->prefix}sf_surveys", "use_widget", "ALTER TABLE {$wpdb->prefix}sf_surveys ADD COLUMN use_widget boolean;");
			//update_option('sf_surveys_db_version', '2.1');
			update_option('sf_surveys_db_version', '4.3');  //Added by Pallavi in 4.3v to set db version
		}
		
		
		if ($wpdb->get_var("SHOW TABLES LIKE '{$wpdb->prefix}sf_survey_questions'") != $wpdb->prefix . 'sf_survey_questions') {
			dbDelta("CREATE TABLE {$wpdb->prefix}sf_survey_questions (
						survey_question_id integer not null auto_increment,
						survey_id integer,
						question varchar(250),
						font varchar(25),
						font_size varchar(10),
						font_color varchar(10),
						answers text,
						priority integer,
						question_type integer default '1',
						active_status_id integer, 
						date_modified timestamp, 
						date_created timestamp,
						PRIMARY KEY (survey_question_id)
					);");

			dbDelta("CREATE INDEX idx_survey_questions ON {$wpdb->prefix}sf_survey_questions(survey_id);");
			
			add_option("sf_survey_questions_db_version", "4.3");
		}
		
		
		if ($wpdb->get_var("SHOW TABLES LIKE '{$wpdb->prefix}sf_survey_rules'") != $wpdb->prefix . 'sf_survey_rules') {
			dbDelta("CREATE TABLE {$wpdb->prefix}sf_survey_rules (
						survey_rule_id integer not null auto_increment,
						survey_question_id integer,	
						answer_index integer,	
						result_answer integer,						
						active_status_id integer, 
						date_modified timestamp, 
						date_created timestamp,
						PRIMARY KEY (survey_rule_id)
					);");

			add_option("sf_survey_rules_db_version", "4.3");
		}
		
		// BEGIN Added By Arvind On 7-AUG-2013  For Add UserInformation
		
		if ($wpdb->get_var("SHOW TABLES LIKE '{$wpdb->prefix}sf_survey_user_information'") != $wpdb->prefix . 'sf_survey_user_information') {
			dbDelta("CREATE TABLE {$wpdb->prefix}sf_survey_user_information (
			user_id integer  auto_increment,
			user_name varchar(150),
			email_id varchar(250),
			PRIMARY KEY (user_id)
			);");
		
		}
		
		if ($wpdb->get_var("SHOW TABLES LIKE '{$wpdb->prefix}sf_survey_results'") != $wpdb->prefix . 'sf_survey_results') {
			dbDelta("CREATE TABLE {$wpdb->prefix}sf_survey_results (
						survey_result_id integer not null auto_increment,
						survey_id integer,
						survey_question_id integer,	
						answer text,	
						active_status_id integer, 
						date_modified timestamp, 
						date_created timestamp,
						user_id integer,
						PRIMARY KEY (survey_result_id)				
					);");
			
			dbDelta("CREATE INDEX idx_survey_results ON {$wpdb->prefix}sf_survey_results(survey_id);");

			add_option("sf_survey_results_db_version", "4.3");
			
	
		}
		else if($wpdb->get_var("SHOW TABLES LIKE '{$wpdb->prefix}sf_survey_results'") == $wpdb->prefix . 'sf_survey_results')
		{
			$sql = "SHOW COLUMNS FROM {$wpdb->prefix}sf_survey_results LIKE 'user_id'";
			if(!$wpdb->get_var($sql) )
			{
				$sql2 = "alter table {$wpdb->prefix}sf_survey_results add user_id integer after date_created";
				$wpdb->query($sql2);
				$sql1 = "alter table {$wpdb->prefix}sf_survey_results add foreign key(user_id) references {$wpdb->prefix}sf_survey_user_information (user_id)";
				$wpdb->query($sql1);
			}						
			
	  }		
	  
// END By Arvind 
		
		if ($wpdb->get_var("SHOW TABLES LIKE '{$wpdb->prefix}sf_survey_stats'") != $wpdb->prefix . 'sf_survey_stats') {
			dbDelta("CREATE TABLE {$wpdb->prefix}sf_survey_stats (
						survey_stat_id integer not null auto_increment,
						survey_id integer,
						imprints integer,
						completions integer,	
						active_status_id integer, 
						date_modified timestamp, 
						date_created timestamp,
						PRIMARY KEY (survey_stat_id)
					);");
			
			dbDelta("CREATE INDEX idx_survey_stats ON {$wpdb->prefix}sf_survey_stats(survey_id);");

			//add_option("sf_survey_stats_db_version", "1.0");
			add_option("sf_survey_stats_db_version", "4.3");   //Added by Pallavi in 4.3v to set db version
		}
		
		update_option("sf_survey_stats_db_version", "4.3");
	}
	
	
} // End Table Class
?>
