var $dialogContent;
var WPMediaFormField;
var currentSFQuestionNumber;
var newSFQuestionNumber;


/*
Reload the current window after a set time
*/
function reloadWindowTimeout() {
	setTimeout('window.location.reload();', 250);
}


/*
Redirect the current window after a set time
*/
function redirectWindowTimeout(iLocation) {
	setTimeout('window.location.href="' + iLocation + '"', 250);
}


/*

*/
function initSFEditor() {
	jQuery("#sfFlowList").sortable({
		axis: 'y',
		revert: true,
		cursor: 'move',
		forcePlaceholderSize: true,
		placeholder: 'sfQuestionDropDiv',		
		start: function(event, ui) {
			currentSFQuestionNumber = (jQuery("#sfFlowList li").index(ui.item)) + 1;
		},
		update: function(event, ui) {
			newSFQuestionNumber = (jQuery("#sfFlowList li").index(ui.item)) + 1;
			updateSFColumns();
		}
	});
		
	jQuery(".colors").miniColors({
		change: function(hex, rgb) {
			
		}
	});

	initSFMediaButtons();
	updateSFColumns();

	jQuery('.sfQuestionDiv .toolbar').width(jQuery('.sfQuestionDiv').width());	
}


/*

*/
function initSFMediaButtons() {
	jQuery('.WPMediaBtn').unbind('click');
		
	jQuery('.WPMediaBtn').each(function() {
		var tmpID = jQuery(this).attr('id').replace('_button', '');
		var imgurl = jQuery('#' + tmpID).val(); 
		if (imgurl) {
			jQuery('#' + tmpID).parent().find('div').remove();
			jQuery('#' + tmpID).after('<div class="survey_funnel_thumbnail" id="' + tmpID + '_tbimage"><img src="' + imgurl + '"></div>');
		}
	});
	
	jQuery('.WPMediaBtn, .survey_funnel_thumbnail').click(function() {
		WPMediaFormField = jQuery(this).attr('id').replace('_button', '');
		WPMediaFormField = WPMediaFormField.replace('_tbimage', '');
		
		tb_show('', 'media-upload.php?type=image&TB_iframe=true');
		return false;
	});	
	
	window.send_to_editor = function(html) {		
		//jQuery('#width').val(jQuery('img', html).attr('width'));
		//jQuery('#height').val(jQuery('img', html).attr('height'));
		
		if (jQuery(html).find('img').size()) {
			imgurl = jQuery(html).find('img').attr('src');
		} else {
			imgurl = jQuery(html).attr('src');
		}
		
		jQuery('#' + WPMediaFormField).parent().find('div').remove();
		jQuery('#' + WPMediaFormField).after('<div class="survey_funnel_thumbnail" id="' + imgurl + '_tbimage"><img src="' + imgurl + '"></div>');
				
		jQuery('#' + WPMediaFormField).val(imgurl);
		tb_remove();
	}
}


/*

*/
function addSFQuestion(iURL) {
	jQuery('#survey_funnel_question [id*=answer_row_]').remove();
	
	$dialogContent = jQuery("#survey_funnel_question");
	
    $dialogContent.dialog({
    	title: "Add Question",
    	closeOnEscape: true,
        modal: true,
        resizable: false,
        width: 460,
        minHeight: 225,
		autoResize: true,

        close: function() {
        	$dialogContent.dialog("destroy");
        	$dialogContent.hide();        	
		},
                
		open: function() {
			$dialogContent.find('#header_display').html('Add');
			$dialogContent.find('#question').val('');
			$dialogContent.find('#first_answer').val('');
			$dialogContent.find('#updateMsg2').html('');
			$dialogContent.find('#question_id').val(0);
			$dialogContent.find('#question').focus();
			$dialogContent.find('#question_type').val(1);
		},
		
        buttons: {			
			"Cancel": function() {
        		$dialogContent.dialog("destroy");
        		$dialogContent.hide();				
			},
			
        	"Add Question": function() {
        		doFormSubmit('Adding Question...', jQuery('#sf_question_form')); 
        		submitAJAX(iURL + '/survey_funnel/json.php?action=ADD_QUESTION', jQuery('#sf_question_form').serialize());
			},			
		}
	}).show();
	
}


/*

*/
function performSFQuestionAdd(iID, iURL) {
	var tmpAnswers = new Array($dialogContent.find('#first_answer').val());
	
	var tmpHTML = '<li id="li_' + iID + '">\
		<div class="sfQuestionDiv">\
			<div class="toolbar">\
				<a href="#" onclick="editSFQuestion(\'' + iID + '\', \'' + iURL + '\');return false;\"><img src="' + iURL + '/survey_funnel/images/btn/edit_btn.png" border="0"></a>\
				<a href="#" onclick="removeSFQuestion(\'' + iID + '\');return false;\"><img src="' + iURL + '/survey_funnel/images/btn/delete_btn.png" border="0"></a>\
			</div>\
			<div class="display">' + $dialogContent.find('#question').val() + '</div>\
			<div class="answerToolbar">[ <a href="#" onclick="jQuery(this).parent().parent().find(\'.answers\').toggle(\'slow\');return false;">Show/Hide Answers</a> ]</div>\
			<div class="answers">';

	$dialogContent.find('[id*=answer_row_] input').each(function() {
		tmpAnswers.push(jQuery(this).val());
	});
	
	jQuery.each(tmpAnswers, function() {
		if (this != '') {
			tmpHTML = tmpHTML + '<div class="answerDisplay">' + this + '</div>';
			tmpHTML = tmpHTML + '<div class="answerRule"><select name="answer_rules[' + iID + '][]" onmousedown="updateSFFlows(this, 1);" class="sfRuleDropDown"><option value=""></option></select></div>';
			tmpHTML = tmpHTML + '<br clear="all">';
		}
	});
	
	tmpHTML = tmpHTML + '</div></div></li>';
	
	jQuery('#sfFlowList').append(tmpHTML);
}


/*

*/
function editSFQuestion(iID, iURL) {
	jQuery('#survey_funnel_question [id*=answer_row_]').remove();
	
	$dialogContent = jQuery("#survey_funnel_question");	
	
    $dialogContent.dialog({
    	title: "Edit Question",
    	closeOnEscape: true,
        modal: true,
        resizable: false,
        width: 460,
        minHeight: 225,
		autoResize: true,
                
        close: function() {
        	$dialogContent.dialog("destroy");
        	$dialogContent.hide();        	
		},
                
		open: function() {
			$dialogContent.find('#header_display').html('Edit');
			$dialogContent.find('#question').val(jQuery('#question_' + iID).val());
			$dialogContent.find('#font').val(jQuery('#font_' + iID).val());
			$dialogContent.find('#font_size').val(jQuery('#font_size_' + iID).val());
			$dialogContent.find('#font_color').val(jQuery('#font_color_' + iID).val());
			$dialogContent.find('#question_id').val(iID);
			$dialogContent.find('#question_type').val(1);
			$dialogContent.find('#question').focus();
			
			var answerCount = 0;
			jQuery.each(jQuery('#answers_' + iID).val().split('|||'), function() {
				if (answerCount == 0) {
					$dialogContent.find('#first_answer').val(this);
				} else {
					$dialogContent.find('#question_table').append('<tr id="answer_row_' + answerCount + '"><td><input type="text" size="30" maxlength="250" name="answers[]" value="' + this + '"></td><td>[ <a href="#" onclick="removeSFAnswer(\'' + answerCount + '\');return false;">Remove</a> ]</td></tr>');
				}
				
				answerCount ++;
			});
						
			$dialogContent.find('#updateMsg2').html('');
		},
		
        buttons: {
			"Cancel": function() {
        		$dialogContent.dialog("destroy");
        		$dialogContent.hide();
			},
        				
        	"Update Question": function() {
        		doFormSubmit('Updating Question...', jQuery('#sf_question_form'));
        		submitAJAX(iURL + '/survey_funnel/json.php?action=UPDATE_QUESTION', jQuery('#sf_question_form').serialize());
			}
		}
	}).show();	
}


/*

*/
function performSFQuestionUpdate(iID, iURL) {
	var tmpAnswers = new Array($dialogContent.find('#first_answer').val());
	
	var tmpHTML = '';

	$dialogContent.find('[id*=answer_row_] input').each(function() {
		tmpAnswers.push(jQuery(this).val());
	});
	
	/*
	jQuery.each(tmpAnswers, function() {
		if (this != '') {
			tmpHTML = tmpHTML + '<div class="answerDisplay">' + this + '</div>';
			tmpHTML = tmpHTML + '<div class="answerRule"><select name="answer_rules[' + iID + '][]" onmousedown="updateSFFlows(this, 1);" class="sfRuleDropDown"><option value=""></option></select></div>';
			tmpHTML = tmpHTML + '<br clear="all">';
		}
	});
	
	jQuery('#li_' + iID + ' .answers').html(tmpHTML);
	*/
	
	var answerDom = jQuery('#li_' + iID + ' .answers').find('.answerDisplay');
	var lastIndex = 0;
	
	jQuery.each(tmpAnswers, function(index, value) {
		if (answerDom.eq(index).size()) {
			answerDom.eq(index).html(value);
			lastIndex = index;
		}
	});
		
	// Add new questions
	if (tmpAnswers.length > answerDom.size()) {		
		jQuery.each(jQuery(tmpAnswers).slice(lastIndex + 1), function() {
			if (this != '') {
				tmpHTML = tmpHTML + '<div class="answerDisplay">' + this + '</div>';
				tmpHTML = tmpHTML + '<div class="answerRule"><select name="answer_rules[' + iID + '][]" onmousedown="updateSFFlows(this, 1);" class="sfRuleDropDown"><option value=""></option></select></div>';
				tmpHTML = tmpHTML + '<br clear="all">';
			}
		});
	
		jQuery('#li_' + iID + ' .answers').append(tmpHTML);
	
	// Remove old questions
	} else if (tmpAnswers.length < answerDom.size()) {
		jQuery('#li_' + iID + ' .answers').find('.answerDisplay').slice(tmpAnswers.length).remove();
		jQuery('#li_' + iID + ' .answers').find('.answerRule').slice(tmpAnswers.length).remove();
		jQuery('#li_' + iID + ' .answers').find('br').slice(tmpAnswers.length).remove();
	}	
}


/*

*/
function addSFContent(iURL) {
	$dialogContent = jQuery("#survey_funnel_content");
	
    $dialogContent.dialog({
    	title: "Add Content",
    	closeOnEscape: true,
        modal: true,
        resizable: false,
        width: 640,
        minHeight: 225,
		autoResize: true,
                
        close: function() {
        	$dialogContent.dialog("destroy");
        	$dialogContent.hide();        	
		},
                
		open: function() {
			$dialogContent.find('#header_display').html('Add');
			$dialogContent.find('#updateMsg2').html('');
			$dialogContent.find('#question_id').val(0);
			$dialogContent.find('#question').val('');
			$dialogContent.find('#question_type').val(2);
			$dialogContent.find('#question').focus();
			
			//$dialogContent.find('#main_content_cell').html('<iframe src="' + iURL + '/survey_funnel/form_templates/wysiwyg_editor.php" width="100%" height="100%" frameborder="0"></iframe>');
		},
		
        buttons: {
			"Cancel": function() {
        		$dialogContent.dialog("destroy");
        		$dialogContent.hide();				
			},
			
        	"Add Content": function() {
        		doFormSubmit('Adding Content...', jQuery('#sf_content_form')); 
        		submitAJAX(iURL + '/survey_funnel/json.php?action=ADD_QUESTION', jQuery('#sf_content_form').serialize());
			}			
		}
	}).show();	
}

/*
// BEGIN Added By Arvind On 7-AUG-2013  For Add UserInformation

*/
function addSFDefaultContent(iURL) {

$dialogContent = jQuery("#survey_funnel_userinfo");

$dialogContent.dialog({
	title: "Add Content",
	closeOnEscape: true,
   modal: true,
   resizable: false,
   width: 640,
   minHeight: 225,
	autoResize: true,
           
   close: function() {
   	$dialogContent.dialog("destroy");
   	$dialogContent.hide();        	
	},
           
	open: function() {
		$dialogContent.find('#header_display').html('Add');
		$dialogContent.find('#updateMsg').html('');
		$dialogContent.find('#question_id').val(0);
		$dialogContent.find('#question_type').val(3);
		$dialogContent.find('#adduserinfo').val(1);
	},
	
   buttons: {
		"Cancel": function() {
   		$dialogContent.dialog("destroy");
   		$dialogContent.hide();				
		},
           		
   	"Add": function() {
   		 
   		doFormSubmit('Adding user information...', jQuery('#sf_userinfo_form')); 
   		submitAJAX(iURL + '/survey_funnel/json.php?action=ADD_QUESTION', jQuery('#sf_userinfo_form').serialize());
   		 }
   		 
   		
	}
}).show();  

}
function performSFUserContentAdd(iID, iURL) {
	
	var tmpAnswers = new Array($dialogContent.find('#first_answer').val());
	
	jQuery('#li_' + iID + ' .answers').html(tmpHTML);
	var tmpHTML = '<li id="li_' + iID + '">\
		<div class="sfQuestionDiv">\
			<div class="toolbar">\
				<a href="#" onclick="removeSFQuestion(\'' + iID + '\');return false;\"><img src="' + iURL + '/survey_funnel/images/btn/delete_btn.png" border="0"></a>\
			</div>\
			<div class="display">' + $dialogContent.find('#add').val() + '</div>\
			<div class="answerToolbar">[ <a href="#" onclick="jQuery(this).parent().parent().find(\'.answers\').toggle(\'slow\');return false;">Show/Hide Answers</a> ]</div>\
			<div class="answers">';
	$dialogContent.find('[id*=answer_row_] input').each(function() {
		tmpAnswers.push(jQuery(this).val());
	});
	
	jQuery.each(tmpAnswers, function() {
		if (this != '') {
			tmpHTML = tmpHTML + '<div class="answerDisplay">' + $dialogContent.find('#add').val() + '</div>';
			tmpHTML = tmpHTML + '<div class="answerRule"><select name="answer_rules[' + iID + '][]" onmousedown="updateSFFlows(this, 1);" class="sfRuleDropDown"><option value=""></option></select></div>';
			tmpHTML = tmpHTML + '<br clear="all">';
		}
	});
	
	tmpHTML = tmpHTML + '</div></div></li>';
	
	
	jQuery('#sfFlowList').append(tmpHTML);
}

// End By Arvind

/*

*/
function performSFContentAdd(iID, iURL) {
	var tmpAnswers = new Array($dialogContent.find('#first_answer').val());
	
	// jQuery('<div/>').text($dialogContent.find('#question').val()).html()
	
	var tmpHTML = '<li id="li_' + iID + '">\
		<div class="sfQuestionDiv">\
			<div class="toolbar">\
				<a href="#" onclick="editSFContent(\'' + iID + '\', \'' + iURL + '\');return false;\"><img src="' + iURL + '/survey_funnel/images/btn/edit_btn.png" border="0"></a>\
				<a href="#" onclick="removeSFQuestion(\'' + iID + '\');return false;\"><img src="' + iURL + '/survey_funnel/images/btn/delete_btn.png" border="0"></a>\
			</div>\
			<div class="display">' + $dialogContent.find('#question').val() + '</div>\
		</div></li>';
	
	jQuery('#sfFlowList').append(tmpHTML);
}


/*

*/
function editSFContent(iID, iURL) {
	$dialogContent = jQuery("#survey_funnel_content");
	
    $dialogContent.dialog({
    	title: "Edit Content",
    	closeOnEscape: true,
        modal: true,
        resizable: false,
        width: 640,
        minHeight: 225,
		autoResize: true,
                
        close: function() {
        	$dialogContent.dialog("destroy");
        	$dialogContent.hide();        	
		},
                
		open: function() {
			//var decodedText = jQuery("<div/>").html(jQuery('#answers_' + iID).val()).text();
			var decodedText = jQuery('#answers_' + iID).val();
			
			$dialogContent.find('#header_display').html('Edit');
			$dialogContent.find('#updateMsg2').html('');
			$dialogContent.find('#question_id').val(iID);
			$dialogContent.find('#question').val(decodedText);
			$dialogContent.find('#question_type').val(2);
			$dialogContent.find('#question').focus();
		},
		
        buttons: {
			"Cancel": function() {
        		$dialogContent.dialog("destroy");
        		$dialogContent.hide();				
			},
        	
        	"Update Content": function() {
        		doFormSubmit('Updating Content...', jQuery('#sf_content_form')); 
        		submitAJAX(iURL + '/survey_funnel/json.php?action=UPDATE_QUESTION', jQuery('#sf_content_form').serialize());
			}			
		}
	}).show();	
}


/*

*/
function addSFAnswer() {
	var newDate = new Date;
	var tmpID = newDate.getTime();
	
	jQuery('#survey_funnel_question #question_table').append('<tr id="answer_row_' + tmpID + '"><td><input type="text" size="30" maxlength="250" name="answers[]" value=""></td><td>[ <a href="#" onclick="removeSFAnswer(\'' + tmpID + '\');return false;">Remove</a> ]</td></tr>');
}


/*

*/
function removeSFAnswer(iID) {
	jQuery('#answer_row_' + iID).fadeOut('fast', function() {
		jQuery(this).remove();
	});
}


/*

*/
function removeSFQuestion(iID) {
	var tmpResp = confirm('Are you sure you want to remove this item?');
	
	if (!tmpResp) {
		return false;
	}
	
	jQuery('#key_' + iID).remove();
	jQuery('#question_' + iID).remove();
	jQuery('#font_' + iID).remove();
	jQuery('#font_size_' + iID).remove();
	jQuery('#font_color_' + iID).remove();
	jQuery('#answers_' + iID).remove();
	jQuery('#priority_' + iID).remove();
	jQuery('#question_type_' + iID).remove();	
	
	jQuery('#li_' + iID).fadeOut('fast', function() {
		jQuery(this).remove();
		updateSFColumns();
	});
}


/*

*/
function updateSFColumns() {
	var tmpPriority = 1;

	var lowNum = currentSFQuestionNumber;
	var highNum = newSFQuestionNumber;
	
	if (newSFQuestionNumber < currentSFQuestionNumber) {
		lowNum = newSFQuestionNumber;
		highNum = currentSFQuestionNumber;
	}
	
	// Update and rule drop down options
	jQuery('.sfRuleDropDown').each(function() {
		updateSFFlows(this, 1);

		if ((jQuery(this).val() >= lowNum) && (jQuery(this).val() <= highNum)) {
			if (jQuery(this).val() == currentSFQuestionNumber) {
				jQuery(this).val(newSFQuestionNumber);
			
			} else if ((jQuery(this).val() <= newSFQuestionNumber) && (currentSFQuestionNumber < newSFQuestionNumber)) {
				var tmpValue = (jQuery(this).val() * 1) - 1;
				jQuery(this).val(tmpValue);
		
			} else if ((jQuery(this).val() >= newSFQuestionNumber) && (currentSFQuestionNumber > newSFQuestionNumber)) {
				var tmpValue = (jQuery(this).val() * 1) + 1;
				jQuery(this).val(tmpValue);
			}
		}
	});
	
	
	jQuery('#sfFlowList li').each(function() {
		var tmpID = jQuery(this).attr('id').replace('li_', '');
			
		jQuery('#column_' + tmpID).val(1);
		jQuery('#priority_' + tmpID).val(tmpPriority);			
		
		jQuery(this).find('.display .questionNumber').remove();
		jQuery(this).find('.display').prepend('<span class="questionNumber">' + tmpPriority + ". &nbsp; </span>");

		tmpPriority ++;		
	});
}



/*

*/
function addSFAnswerQuestion() {
	var newDate = new Date;
	var tmpID = newDate.getTime();

	jQuery('#trigger_question_row').after('<tr id="answer_' + tmpID + '"><td align="right" nowrap>&nbsp;</td><td width="100%"><label><input id="' + tmpID + '" type="hidden" size="35" name="trigger_answers[]" onfocus="cleanFormError(this);"> <input id="' + tmpID + '_button" class="WPMediaBtn" type="button" value="Browse..."> &nbsp;Start Question: <select name="start_flows[]" onmousedown="updateSFFlows(this);" class="sfRuleDropDown"><option value="1">1</option></select>&nbsp;[ <a href="#" onclick="removeSFTriggerAnswer(' + tmpID + ');return false;">Remove</a> ]</label></td></tr>');

	initSFMediaButtons();
	
	/*
	jQuery('#' + tmpID + '_button').click(function() {
		WPMediaFormField = tmpID;
		tb_show('', 'media-upload.php?type=image&TB_iframe=true');
		return false;
	});	
	*/
}


/*

*/
function removeSFTriggerAnswer(iID) {
	jQuery('#answer_' + iID).fadeOut('fast', function() {
		jQuery(this).remove();
	});
}


/*

*/
function updateSFFlows(iSelect, iStartNumber) {
	if (iStartNumber == null) {
		iStartNumber = 2;
	}	
	
	var tmpCount = jQuery("#sfFlowList li").size();	
	
	for (i = iStartNumber; i <= tmpCount; i ++) {
		if (!jQuery(iSelect).find('option[value="' + i + '"]').size()) {
			jQuery(iSelect).append('<option value="' + i + '">' + i + '</option>');
		}
	}
}


/*

*/
function copySFFunnel(iID, iURL) {
	var tmpName = prompt('Please specify the new survey name');
	
	if (tmpName) {	
	
		//2.0.9
	var data = {
		action: 'sf_clone',
		survey_id: iID,
		url: iURL,
		survey_name: tmpName
	};
	
	//2.0.9
	jQuery.post(ajaxurl, data, function(response, textStatus) {
	
	
		//handleAJAXResponse(response, textStatus);//2.0.9
	}, "json");
	
	reloadWindowTimeout();
		//submitAJAX(iURL + '/survey_funnel/json.php?action=COPY_FUNNEL',  {survey_id: iID, survey_name: tmpName, url: iURL});//2.0.9
	}
}





function deleteSFFunnel(iID, iURL) {
	
	var answer = confirm("Are you sure you want to delete this funnel?")
	if (answer) {	
	
	//2.0.9
	var data = {
		action: 'sf_delete',
		survey_id: iID,
		url: iURL
	};
	
	//2.0.9
	jQuery.post(ajaxurl, data, function(response, textStatus) {
	
	
		//handleAJAXResponse(response, textStatus);//2.0.9
	}, "json");
	
		//submitAJAX(iURL + '/survey_funnel/json.php?action=DELETE_FUNNEL',  {survey_id: iID,  url: iURL});//2.0.9
		reloadWindowTimeout();
	}
}



/*

*/
function keepSFAlive(iURL) {
	jQuery.get(iURL + '/survey_funnel/json.php?action=KEEP_ALIVE',
   		function(data){
   			setTimeout('keepSFAlive(\'' + iURL + '\');', 30000);
   		}, 
   	"html");	
}


jQuery(document).ready(function() {
jQuery('#resetTriggerImage').click(function(){
	
jQuery('#lightbox_image').val(null);
//jQuery('#tab_image').val(null);	
jQuery('.survey_funnel_thumbnail').hide();
return false;
});

});